<?php
/*------------------------------------------------------------------------

# TZ Portfolio Extension

# ------------------------------------------------------------------------

# author    DuongTVTemPlaza

# copyright Copyright (C) 2012 templaza.com. All Rights Reserved.

# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

# Websites: http://www.templaza.com

# Technical Support:  Forum - http://templaza.com/Forum

-------------------------------------------------------------------------*/

defined('_JEXEC') or die();

require_once JPATH_SITE.'/modules/mod_tz_social/libraries/HTTPFetcher.php';
require_once JPATH_SITE.'/modules/mod_tz_social/libraries/readfile.php';

class modTZSocialHelper{
    public static function getCounter($params){
        $obj    = new stdClass();

        if($params -> get('show_pinterest_count',1)){
            $obj -> pinterest   = self::_getPinterestCounter(JUri::current());
        }
        if($params -> get('show_linkedin_count',1)){
            $obj -> linkedin    = self::_getLinkedInCounter(JUri::current());
        }
        if($params -> get('show_facebook_count',0)){
            $obj -> facebook    = self::_getFacebookCounter(JUri::current());
        }
        if($params -> get('show_twitter_count',0)){
            $obj -> twitter     = self::_getTwitterCounter(JUri::current());
        }
        if($params -> get('show_google_count',0)){
            $obj -> googleplus  = self::_getPlusOne(JUri::current());
        }
        return $obj;
    }
    protected static function _getPinterestCounter($url){
        $link   = 'http://api.pinterest.com/v1/urls/count.json?callback=&url='.urlencode($url);
        $fetch  = new Services_Yadis_PlainHTTPFetcher();
        if($content   = $fetch -> get($link)){
            if(isset($content -> body) && $content -> body){
                $body       = $content -> body;
                if($body    = json_decode(str_replace(array('(',')'),'',$body))){
                    return isset($body ->count)?$body ->count:0;
                }
            }
        }
        return 0;
    }

    protected static function _getLinkedInCounter($url){
        $link   = 'http://www.linkedin.com/countserv/count/share?format=json&url='.$url;
        $fetch  = new Services_Yadis_PlainHTTPFetcher();
        if($content   = $fetch -> get($link)){
            if(isset($content -> body) && $content -> body){
                $body       = $content -> body;
                if($body = json_decode($body)){
                    return isset($body ->count)?$body ->count:0;
                }
            }
        }
        return 0;
    }

    protected static function _getFacebookCounter($url){
        $fetch      = new Services_Yadis_PlainHTTPFetcher();
        $link       = 'http://graph.facebook.com/?ids='.$url;
        if($content    = $fetch -> get($link)){
            if(isset($content -> body) && $content -> body){
                $body   = json_decode($content -> body);
                return (isset($body -> $url) && $body -> $url)?$body -> $url ->shares:0;
            }
        }
        return 0;
    }

    protected static function _getTwitterCounter($url){
        $fetch      = new Services_Yadis_PlainHTTPFetcher();
        $link   = 'http://urls.api.twitter.com/1/urls/count.json?url='.$url;
        if($content = $fetch -> get($link)){
            if(isset($content -> body) && $content -> body){
                $body   = $content -> body;
                if($body = json_decode($body)){
                    return isset($body ->count)?$body ->count:0;
                }
            }
        }
        return 0;
    }

    protected static function _getPlusOne($url){
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, "https://clients6.google.com/rpc");
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_POSTFIELDS, '[{"method":"pos.plusones.get","id":"p","params":{"nolog":true,"id":"'.rawurldecode($url).'","source":"widget","userId":"@viewer","groupId":"@self"},"jsonrpc":"2.0","key":"p","apiVersion":"v1"}]');
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-type: application/json'));
        $curl_results = curl_exec ($curl);
        curl_close ($curl);
        $json = json_decode($curl_results, true);
        return isset($json[0]['result']['metadata']['globalCounts']['count'])?intval( $json[0]['result']['metadata']['globalCounts']['count'] ):0;
    }
}