<?php
/**
 * @package     Joomla.Site
 * @subpackage  mod_login
 *
 * @copyright   Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

JHtml::_('behavior.keepalive');
if(version_compare(JVERSION,'3.0','ge')){
    JHtml::_('bootstrap.tooltip');
}
$usersConfig = JComponentHelper::getParams('com_users');
?>
<form action="<?php echo JRoute::_('index.php', true, $params->get('usesecure')); ?>" method="post" id="login-form" class="form-inline">
	<?php if ($params->get('pretext')) : ?>
		<div class="pretext">
		<p><?php echo $params->get('pretext'); ?></p>
		</div>
	<?php endif; ?>
	<div class="userdata">
		<div id="form-login-username" class="control-group">
			<div class="controls">
				<?php if (!$params->get('usetext')) : ?>
					<div class="input-prepend control-group">
						<span class="add-on">
							<span class="icon-user hasTooltip" title="<?php echo JText::_('MOD_LOGIN_VALUE_USERNAME') ?>"></span>
							<label for="modlgn-username" class="element-invisible"><?php echo JText::_('MOD_LOGIN_VALUE_USERNAME'); ?></label>
						</span>
						<input id="modlgn-username" type="text" name="username" class="input-small" tabindex="0" size="18" placeholder="<?php echo JText::_('MOD_LOGIN_VALUE_USERNAME') ?>" />
                        <?php if ($usersConfig->get('allowUserRegistration')) : ?>
                        <a href="<?php echo JRoute::_('index.php?option=com_users&view=remind'); ?>" class="hasTooltip input-icon"
                           title="<?php echo JText::_('MOD_LOGIN_FORGOT_YOUR_USERNAME'); ?>">
                            <i class="fa fa-question-circle"></i>
                        </a>
                        <?php endif;?>
					</div>
				<?php else: ?>
					<label for="modlgn-username"><?php echo JText::_('MOD_LOGIN_VALUE_USERNAME') ?></label>
						<input id="modlgn-username" type="text" name="username" class="input-small" tabindex="0" size="18" placeholder="<?php echo JText::_('MOD_LOGIN_VALUE_USERNAME') ?>" />
				<?php endif; ?>
			</div>
		</div>
		<div id="form-login-password" class="control-group">
			<div class="controls">
				<?php if (!$params->get('usetext')) : ?>
					<div class="input-prepend control-group">
						<span class="add-on">
							<span class="icon-lock hasTooltip" data-placement="bottom" title="<?php echo JText::_('JGLOBAL_PASSWORD') ?>">
							</span>
								<label for="modlgn-passwd" class="element-invisible"><?php echo JText::_('JGLOBAL_PASSWORD'); ?>
							</label>
						</span>
						<input id="modlgn-passwd" type="password" name="password" class="input-small"
                               tabindex="0" size="18"
                               placeholder="<?php echo JText::_('JGLOBAL_PASSWORD') ?>" />
                        <?php if ($usersConfig->get('allowUserRegistration')) : ?>
                        <a href="<?php echo JRoute::_('index.php?option=com_users&view=reset'); ?>"
                           class="hasTooltip input-icon" data-placement="bottom"
                            title="<?php echo JText::_('MOD_LOGIN_FORGOT_YOUR_PASSWORD'); ?>">
                            <i class="fa fa-question-circle"></i>
                        </a>
                        <?php endif;?>
				</div>
				<?php else: ?>
					<label for="modlgn-passwd"><?php echo JText::_('JGLOBAL_PASSWORD') ?></label>
					<input id="modlgn-passwd" type="password" name="password" class="input-small" tabindex="0" size="18" placeholder="<?php echo JText::_('JGLOBAL_PASSWORD') ?>" />
				<?php endif; ?>

			</div>
		</div>
		<?php if (JPluginHelper::isEnabled('system', 'remember')) : ?>
		<div id="form-login-remember" class="control-group">
			<label for="modlgn-remember" class="checkbox">
                <input id="modlgn-remember" type="checkbox"
                       data-toggle="checkbox"
                       name="remember" class="inputbox" value="yes"/>
                <?php echo JText::_('MOD_LOGIN_REMEMBER_ME'); ?>
            </label>
		</div>
		<?php endif; ?>
		<div id="form-login-submit" class="control-group">
			<div class="controls">
				<button type="submit" tabindex="0" name="Submit" class="btn btn-embossed"><?php echo JText::_('JLOGIN') ?></button>
                <?php if ($usersConfig->get('allowUserRegistration')) : ?>
                <a class="btn btn-embossed" href="<?php echo JRoute::_('index.php?option=com_users&view=registration'); ?>">
                        <?php echo JText::_('MOD_LOGIN_REGISTER'); ?></a>
                <?php endif;?>
			</div>
		</div>

		<input type="hidden" name="option" value="com_users" />
		<input type="hidden" name="task" value="user.login" />
		<input type="hidden" name="return" value="<?php echo $return; ?>" />
		<?php echo JHtml::_('form.token'); ?>
	</div>
	<?php if ($params->get('posttext')) : ?>
		<div class="posttext">
		<p><?php echo $params->get('posttext'); ?></p>
		</div>
	<?php endif; ?>
</form>
